Skip to content

Introduction

The Hypatos API is organized around REST. The majority of the endpoints provide CRUD functionality for resources. The API is also exposing Intent Resources which mimic user intents or actions.

The Hypatos API uses OAuth 2.0 Client Credential Grant to authenticate requests. Before making any requests to any endpoint a client must authenticate with the authorization server and requests an access token from the token endpoint.

  POST /auth/token HTTP/1.1
  Host: api.cloud.hypatos.ai
  Content-Type: application/x-www-form-urlencoded
  Authorization: Basic dXNlcm5hbWU6cGFzc3dvcmQ=

  grant_type=client_credentials

Authorization header contains client_id:client_secret encoded as explained in RFC Client Password section.

If the authorization server authenticated the client successfully, an access token is issued. Here is an example successful response:

  HTTP/1.1 200 OK
  Content-Type: application/json;charset=UTF-8
  Cache-Control: no-store
  Pragma: no-cache

  {
    "access_token": "mF_9.B5f-4.1JqM",
    "expires_in": 86400,
    "scope": "enrichment.write files.read",
    "token_type": "Bearer",
  }

This token can be used to authenticate the requests to API endpoints by sending a Bearer token in the Authorization HTTP header. The following example demonstrates how to use the access token to retrieve a list of documents.

  GET /v2/documents HTTP/1.1
  Host: api.cloud.hypatos.ai
  Authorization: Bearer mF_9.B5f-4.1JqM

Versioning

Changes to this API are released regularly. We use Semantic Versioning 2.0.0 scheme for versioning so that the clients can identify any backward-incompatible changes easily. Briefly summarized one can say, if the MAJOR version of the new API version didn't change you can expect the new version to be backward-compatible.

Rate limits

In order to maximise the stability of our API, we institue rate limits for all of API endpoints. Clients who send too many requests over a given period of time will see error responses that show up as status code 429 Too Many Requests.

When you see error responses with status code 429, it means you exhausted your current quota and need to withhold from sending further requests until the quota is reset. We encourage you not to wait until you get a 429 error but to monitor your quota in each request. In each response you receive from the API, you will find HTTP headers providing the details about your current quota. Here is the list of the HTTP headers:

  • x-ratelimit-limit: Indicates the quota associated to the client in the current time-window followed by the description of the quota policy.
  • x-ratelimit-remaining: Indicates the number of remaining requests in the current time-window
  • x-ratelimit-reset: Indicates the number of seconds until quota reset of the current time-window

Please note that IETF is currently in the process of publishing a standard for these headers. Please explore the draft for more details.

A basic technique to gracefully handle rate limits is watch for your quota permanently and increase the time between your request as the quota is decreasing. To recover from a 429 error you need a retry mechanism following an exponential backoff schedule.

Download OpenAPI description
Overview
License
Languages
Servers
API EU
https://api.cloud.hypatos.ai/v2
API US
https://api.cloud.hypatos.com/v2
Mock server
https://hypatos.redocly.app/_mock/openapi
Operations

Endpoints for management of files

Operations

Endpoints for document management

Operations

Endpoints for data enrichment

Operations

Request

Security
OAuth2(Required scopes:
enrichment.write
)
Bodyapplication/jsonrequired
externalIdstring^\S+$required

External id of the goods receipt that is globally unique across the provided goods receipt data

Example: "GOODS_RECEIPT-0001"
externalClientIdstring

Identifier of the client entity in the source system which can be used to separate data

Example: "EXTERNAL_CLIENT_ID"
documentIdstring^[0-9a-fA-F]{24}$

Document id that was assigned during upload to Hypatos

Example: "63cac12c37bb02accb396cbf"
documentsArray of objects(document)
goodsReceiptNumberstring

Goods receipt number provided in the source system

Example: "GR123456789"
externalCompanyIdstring

External unique id of the company in the source system

Example: "DE01"
externalSupplierIdstring

External unique id of the supplier in the source system

Example: "0000100000"
fiscalYearLabelstring

Label used in the source system for the fiscal year that the goods receipt was posted in

Example: "2023"
issuedDatestring(date)

Date when the good receipt document was issued

Example: "2024-12-31"
createdDatestring(date)

Date when the goods receipt was created in the source system

Example: "2025-06-30"
postingDatestring(date)

Date when the goods receipt was posted

Example: "2025-06-30"
headerTextstring

Header text describing the goods receipt

Example: "doc header text"
statusstring

Status of the goods receipt as defined in the source system

Example: "POSTED"
deliveryNoteNumberstring

Delivery note number associated with the goods receipt

Example: "DN789456123"
isReversalboolean

Indicator if the goods receipt is a reversal

Example: false
customFieldsobject(customFields)

List of key value pairs containing custom fields from the source system

customMetadataobject(JsonObject)

Any nested structure with metadata that source system needs to send

Example: {"someTopLevelProperty":"value1","someNestedProperty":{"nestedProperty":"value2"},"someArrayProperty":["value3","value4"]}
goodsReceiptLinesArray of objects(goodsReceiptLine)non-emptyrequired
goodsReceiptLines[].​goodsReceiptLineNumberstring

Number of the goods receipt line (unique within the purchase order)

Example: "GRLINE-0001"
goodsReceiptLines[].​externalCompanyIdstring

Company ID associated with the line item.

Example: "DE01"
goodsReceiptLines[].​externalPurchaseOrderIdstring

ID of the related purchase order.

Example: "4500016221"
goodsReceiptLines[].​purchaseOrderLineNumberstring

Line number of the purchase order being received.

Example: "00010"
goodsReceiptLines[].​typestring

Type of item received (e.g., Material, Service).

Example: "Service"
goodsReceiptLines[].​quantitynumber(double)

Quantity of items received.

Example: 2
goodsReceiptLines[].​unitOfMeasurestring

Unit of measure for the quantity.

Example: "kg"
goodsReceiptLines[].​itemTextstring

Descriptive text for the line item.

Example: "Dell Laptop Latitude D630"
goodsReceiptLines[].​statusstring

Status of goods receipt line as defined in source system (e.g. “invoiced” or “open”)

Example: "invoiced"
goodsReceiptLines[].​materialobject(material)
goodsReceiptLines[].​plantstring

Receiving plant or location.

Example: "PLANT-001"
goodsReceiptLines[].​customFieldsobject(customFields)

List of key value pairs containing custom fields from the source system

goodsReceiptLines[].​customMetadataobject(JsonObject)

Any nested structure with metadata that source system needs to send

Example: {"someTopLevelProperty":"value1","someNestedProperty":{"nestedProperty":"value2"},"someArrayProperty":["value3","value4"]}
curl -i -X POST \
  https://api.cloud.hypatos.ai/v2/enrichment/goods-receipts \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
  -H 'Content-Type: application/json' \
  -d '{
    "externalId": "GOODS_RECEIPT-0001",
    "externalClientId": "EXTERNAL_CLIENT_ID",
    "documentId": "63cac12c37bb02accb396cbf",
    "documents": [
      {
        "id": "63cac12c37bb02accb396cae",
        "type": "invoice"
      }
    ],
    "goodsReceiptNumber": "GR123456789",
    "externalCompanyId": "DE01",
    "externalSupplierId": "0000100000",
    "fiscalYearLabel": "2023",
    "issuedDate": "2024-12-31",
    "createdDate": "2025-06-30",
    "postingDate": "2025-06-30",
    "headerText": "doc header text",
    "status": "POSTED",
    "deliveryNoteNumber": "DN789456123",
    "isReversal": false,
    "customFields": {
      "property1": "string",
      "property2": "string"
    },
    "customMetadata": {
      "someTopLevelProperty": "value1",
      "someNestedProperty": {
        "nestedProperty": "value2"
      },
      "someArrayProperty": [
        "value3",
        "value4"
      ]
    },
    "goodsReceiptLines": [
      {
        "goodsReceiptLineNumber": "GRLINE-0001",
        "externalCompanyId": "DE01",
        "externalPurchaseOrderId": "4500016221",
        "purchaseOrderLineNumber": "00010",
        "type": "Service",
        "quantity": 2,
        "unitOfMeasure": "kg",
        "itemText": "Dell Laptop Latitude D630",
        "status": "invoiced",
        "material": {
          "externalId": "2a6300181f08402e710ea3f180214bc1",
          "supplierNumber": "123456789",
          "type": "Operating Supplies",
          "group": "Electronics",
          "description": "Dell Laptop Latitude D630",
          "manufacturer": "Acme Corporation",
          "manufacturerNumber": "ACME-12345",
          "unspsc": "43211508"
        },
        "plant": "PLANT-001",
        "customFields": {
          "property1": "string",
          "property2": "string"
        },
        "customMetadata": {
          "someTopLevelProperty": "value1",
          "someNestedProperty": {
            "nestedProperty": "value2"
          },
          "someArrayProperty": [
            "value3",
            "value4"
          ]
        }
      }
    ]
  }'

Responses

Successfully inserted

Bodyapplication/json
idstringrequired
Example: "3a429dc8-56d4-42ef-a4cf-2ebc9ad1ef38"
Response
application/json
{ "id": "3a429dc8-56d4-42ef-a4cf-2ebc9ad1ef38" }

Request

Security
OAuth2(Required scopes:
enrichment.write
)
Path
externalIdstringrequired

Previously sent externalId

Bodyapplication/merge-patch+jsonrequired
externalIdstring^\S+$required

External id of the goods receipt that is globally unique across the provided goods receipt data

Example: "GOODS_RECEIPT-0001"
externalClientIdstring

Identifier of the client entity in the source system which can be used to separate data

Example: "EXTERNAL_CLIENT_ID"
documentIdstring^[0-9a-fA-F]{24}$

Document id that was assigned during upload to Hypatos

Example: "63cac12c37bb02accb396cbf"
documentsArray of objects(document)
goodsReceiptNumberstring

Goods receipt number provided in the source system

Example: "GR123456789"
externalCompanyIdstring

External unique id of the company in the source system

Example: "DE01"
externalSupplierIdstring

External unique id of the supplier in the source system

Example: "0000100000"
fiscalYearLabelstring

Label used in the source system for the fiscal year that the goods receipt was posted in

Example: "2023"
issuedDatestring(date)

Date when the good receipt document was issued

Example: "2024-12-31"
createdDatestring(date)

Date when the goods receipt was created in the source system

Example: "2025-06-30"
postingDatestring(date)

Date when the goods receipt was posted

Example: "2025-06-30"
headerTextstring

Header text describing the goods receipt

Example: "doc header text"
statusstring

Status of the goods receipt as defined in the source system

Example: "POSTED"
deliveryNoteNumberstring

Delivery note number associated with the goods receipt

Example: "DN789456123"
isReversalboolean

Indicator if the goods receipt is a reversal

Example: false
customFieldsobject(customFields)

List of key value pairs containing custom fields from the source system

customMetadataobject(JsonObject)

Any nested structure with metadata that source system needs to send

Example: {"someTopLevelProperty":"value1","someNestedProperty":{"nestedProperty":"value2"},"someArrayProperty":["value3","value4"]}
goodsReceiptLinesArray of objects(goodsReceiptLine)non-emptyrequired
goodsReceiptLines[].​goodsReceiptLineNumberstring

Number of the goods receipt line (unique within the purchase order)

Example: "GRLINE-0001"
goodsReceiptLines[].​externalCompanyIdstring

Company ID associated with the line item.

Example: "DE01"
goodsReceiptLines[].​externalPurchaseOrderIdstring

ID of the related purchase order.

Example: "4500016221"
goodsReceiptLines[].​purchaseOrderLineNumberstring

Line number of the purchase order being received.

Example: "00010"
goodsReceiptLines[].​typestring

Type of item received (e.g., Material, Service).

Example: "Service"
goodsReceiptLines[].​quantitynumber(double)

Quantity of items received.

Example: 2
goodsReceiptLines[].​unitOfMeasurestring

Unit of measure for the quantity.

Example: "kg"
goodsReceiptLines[].​itemTextstring

Descriptive text for the line item.

Example: "Dell Laptop Latitude D630"
goodsReceiptLines[].​statusstring

Status of goods receipt line as defined in source system (e.g. “invoiced” or “open”)

Example: "invoiced"
goodsReceiptLines[].​materialobject(material)
goodsReceiptLines[].​plantstring

Receiving plant or location.

Example: "PLANT-001"
goodsReceiptLines[].​customFieldsobject(customFields)

List of key value pairs containing custom fields from the source system

goodsReceiptLines[].​customMetadataobject(JsonObject)

Any nested structure with metadata that source system needs to send

Example: {"someTopLevelProperty":"value1","someNestedProperty":{"nestedProperty":"value2"},"someArrayProperty":["value3","value4"]}
curl -i -X PATCH \
  'https://api.cloud.hypatos.ai/v2/enrichment/goods-receipts/{externalId}' \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>' \
  -H 'Content-Type: application/merge-patch+json' \
  -d '{
    "externalId": "GOODS_RECEIPT-0001",
    "externalClientId": "EXTERNAL_CLIENT_ID",
    "documentId": "63cac12c37bb02accb396cbf",
    "documents": [
      {
        "id": "63cac12c37bb02accb396cae",
        "type": "invoice"
      }
    ],
    "goodsReceiptNumber": "GR123456789",
    "externalCompanyId": "DE01",
    "externalSupplierId": "0000100000",
    "fiscalYearLabel": "2023",
    "issuedDate": "2024-12-31",
    "createdDate": "2025-06-30",
    "postingDate": "2025-06-30",
    "headerText": "doc header text",
    "status": "POSTED",
    "deliveryNoteNumber": "DN789456123",
    "isReversal": false,
    "customFields": {
      "property1": "string",
      "property2": "string"
    },
    "customMetadata": {
      "someTopLevelProperty": "value1",
      "someNestedProperty": {
        "nestedProperty": "value2"
      },
      "someArrayProperty": [
        "value3",
        "value4"
      ]
    },
    "goodsReceiptLines": [
      {
        "goodsReceiptLineNumber": "GRLINE-0001",
        "externalCompanyId": "DE01",
        "externalPurchaseOrderId": "4500016221",
        "purchaseOrderLineNumber": "00010",
        "type": "Service",
        "quantity": 2,
        "unitOfMeasure": "kg",
        "itemText": "Dell Laptop Latitude D630",
        "status": "invoiced",
        "material": {
          "externalId": "2a6300181f08402e710ea3f180214bc1",
          "supplierNumber": "123456789",
          "type": "Operating Supplies",
          "group": "Electronics",
          "description": "Dell Laptop Latitude D630",
          "manufacturer": "Acme Corporation",
          "manufacturerNumber": "ACME-12345",
          "unspsc": "43211508"
        },
        "plant": "PLANT-001",
        "customFields": {
          "property1": "string",
          "property2": "string"
        },
        "customMetadata": {
          "someTopLevelProperty": "value1",
          "someNestedProperty": {
            "nestedProperty": "value2"
          },
          "someArrayProperty": [
            "value3",
            "value4"
          ]
        }
      }
    ]
  }'

Responses

Successfully updated

Bodyapplication/json
externalIdstring^\S+$required

External id of the goods receipt that is globally unique across the provided goods receipt data

Example: "GOODS_RECEIPT-0001"
externalClientIdstring

Identifier of the client entity in the source system which can be used to separate data

Example: "EXTERNAL_CLIENT_ID"
documentIdstring^[0-9a-fA-F]{24}$

Document id that was assigned during upload to Hypatos

Example: "63cac12c37bb02accb396cbf"
documentsArray of objects(document)
goodsReceiptNumberstring

Goods receipt number provided in the source system

Example: "GR123456789"
externalCompanyIdstring

External unique id of the company in the source system

Example: "DE01"
externalSupplierIdstring

External unique id of the supplier in the source system

Example: "0000100000"
fiscalYearLabelstring

Label used in the source system for the fiscal year that the goods receipt was posted in

Example: "2023"
issuedDatestring(date)

Date when the good receipt document was issued

Example: "2024-12-31"
createdDatestring(date)

Date when the goods receipt was created in the source system

Example: "2025-06-30"
postingDatestring(date)

Date when the goods receipt was posted

Example: "2025-06-30"
headerTextstring

Header text describing the goods receipt

Example: "doc header text"
statusstring

Status of the goods receipt as defined in the source system

Example: "POSTED"
deliveryNoteNumberstring

Delivery note number associated with the goods receipt

Example: "DN789456123"
isReversalboolean

Indicator if the goods receipt is a reversal

Example: false
customFieldsobject(customFields)

List of key value pairs containing custom fields from the source system

customMetadataobject(JsonObject)

Any nested structure with metadata that source system needs to send

Example: {"someTopLevelProperty":"value1","someNestedProperty":{"nestedProperty":"value2"},"someArrayProperty":["value3","value4"]}
goodsReceiptLinesArray of objects(goodsReceiptLine)non-emptyrequired
goodsReceiptLines[].​goodsReceiptLineNumberstring

Number of the goods receipt line (unique within the purchase order)

Example: "GRLINE-0001"
goodsReceiptLines[].​externalCompanyIdstring

Company ID associated with the line item.

Example: "DE01"
goodsReceiptLines[].​externalPurchaseOrderIdstring

ID of the related purchase order.

Example: "4500016221"
goodsReceiptLines[].​purchaseOrderLineNumberstring

Line number of the purchase order being received.

Example: "00010"
goodsReceiptLines[].​typestring

Type of item received (e.g., Material, Service).

Example: "Service"
goodsReceiptLines[].​quantitynumber(double)

Quantity of items received.

Example: 2
goodsReceiptLines[].​unitOfMeasurestring

Unit of measure for the quantity.

Example: "kg"
goodsReceiptLines[].​itemTextstring

Descriptive text for the line item.

Example: "Dell Laptop Latitude D630"
goodsReceiptLines[].​statusstring

Status of goods receipt line as defined in source system (e.g. “invoiced” or “open”)

Example: "invoiced"
goodsReceiptLines[].​materialobject(material)
goodsReceiptLines[].​plantstring

Receiving plant or location.

Example: "PLANT-001"
goodsReceiptLines[].​customFieldsobject(customFields)

List of key value pairs containing custom fields from the source system

goodsReceiptLines[].​customMetadataobject(JsonObject)

Any nested structure with metadata that source system needs to send

Example: {"someTopLevelProperty":"value1","someNestedProperty":{"nestedProperty":"value2"},"someArrayProperty":["value3","value4"]}
Response
application/json
{ "externalId": "GOODS_RECEIPT-0001", "externalClientId": "EXTERNAL_CLIENT_ID", "documentId": "63cac12c37bb02accb396cbf", "documents": [ {} ], "goodsReceiptNumber": "GR123456789", "externalCompanyId": "DE01", "externalSupplierId": "0000100000", "fiscalYearLabel": "2023", "issuedDate": "2024-12-31", "createdDate": "2025-06-30", "postingDate": "2025-06-30", "headerText": "doc header text", "status": "POSTED", "deliveryNoteNumber": "DN789456123", "isReversal": false, "customFields": { "property1": "string", "property2": "string" }, "customMetadata": { "someTopLevelProperty": "value1", "someNestedProperty": {}, "someArrayProperty": [] }, "goodsReceiptLines": [ {} ] }

Request

Security
OAuth2(Required scopes:
enrichment.delete
)
Path
externalIdstringrequired

Previously sent externalId

curl -i -X DELETE \
  'https://api.cloud.hypatos.ai/v2/enrichment/goods-receipts/{externalId}' \
  -H 'Authorization: Bearer <YOUR_TOKEN_HERE>'

Responses

Successfully deleted

Response
No content

Endpoints for company management

Operations

Endpoints for project management

Operations

Endpoints for e-invoices

Operations

Endpoints serving project-scoped documents as XML

Operations
Operations
Operations
Operations